var unreadCount = 0;
var showMediaUploadAlert = true;
var enableNotificationBool = true;
var focusblur = "blured";
var previousClass = "";
var TEXTBOXSL = '';
var SEND_BUTTON = '';
var nodeToBeClicked = "";
var dockCounterDiscord = 0;
var kevent;

var shouldAddLayerObserver = true;
var isLinkAttached = false;

//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function(title, options) {
    alert("notif received");
    webkit.messageHandlers.notification.postMessage(["Discord", title, options.body, unreadCount]);
    countMethod();
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {
    callback('granted');
};

//injects this into webpage to listen to the camera request

(function() {
    
    if (!window.navigator) window.navigator = {};
    
    //if getuserMedia is called -> If the user requests native camera
    
    window.navigator.getUserMedia = function() {
        
        webkit.messageHandlers.callbackHandler.postMessage(arguments);
        
    };
    
})();

window.onload = function() {
    
    var dismissButton = document.querySelector('div.notice-dismiss');
    var downloadButton = document.querySelector('button.btn-download-apps');
    var downloadBanner = document.querySelector("closeButton-3cJIM4");
    
    if (dismissButton) {
        dismissButton.click();
    }
    if (downloadButton) {
        downloadButton.parentNode.removeChild(downloadButton);
    }
    if (downloadBanner) {
        downloadBanner.click();
    }
    
    if (navigator.appVersion.indexOf("10_11") > -1) {
        showMediaUploadAlert = true;
    } else {
        showMediaUploadAlert = false;
    }
    
    setTimeout(mutationObserverHandler, 3500);
    setTimeout(addScheduler, 3500);
    addLayerObserver();
    
    countMethod();
    
    setInterval(function() {
        countMethod();
    }, 2000);
    
    
};


jQuery(document).on('keyup', TEXTBOXSL, function(e) {
    alert("keyup_TEXT_BOX");
    alert(e.which);
    
    if (this.textContent.length >= 1 && this.textContent.length < 5) {
        //this.setAttribute("spellcheck",false);
    }
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
        
        webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
    } else {
        //isLinkAttached = false;
    }
});


function addCustomEmoji() {
    if ($('input.file-input').length) {
        prompt("attachGif");
        $('input.file-input').click();
        console.log("Check");
    } else {
        selectAChatAlert();
    }
}

function enableNotification() {
    enableNotificationBool = true;
}

function addLayerObserver() {
    var target = document.querySelector("div.layer");
    //alert("layer target "+target);
    if (target) {
        if (shouldAddLayerObserver) {
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) {
                    //alert("layer mutation "+mutation.type);
                    removeAppDownloadLink();
                });
            });
            
            var config = {
            attributes: true,
            childList: true,
            characterData: true,
            subtree: true
            };
            observer.observe(target, config);
            alert("Layer Observer Added");
            shouldAddLayerObserver = false;
        }
    } else {
        setTimeout(function() {
            addLayerObserver();
        }, 2000);
    }
}

function removeAppDownloadLink() {
    //alert("remove links");
    var downloadBtn = document.querySelector("button.btn-download-apps");
    if (downloadBtn) {
        //alert("found btn");
        downloadBtn.style.display = "none";
    }
    
    var dismissButton = document.querySelector('div.notice-dismiss');
    var downloadButton = document.querySelector('button.btn-download-apps');
    var downloadBanner = document.querySelector("closeButton-3cJIM4");
    
    if (dismissButton) {
        dismissButton.click();
    }
    if (downloadButton) {
        downloadButton.parentNode.removeChild(downloadButton);
    }
    if (downloadBanner) {
        downloadBanner.click();
    }
    
    var banner = document.querySelector("div.flexChild-1KGW5q");
    if (banner) {
        //alert("found banner");
        banner.style.display = "none";
    }
}

function mutationObserverHandler() {
    
    var dismissButton = document.querySelector('div.notice-dismiss');
    var downloadButton = document.querySelector('button.btn-download-apps');
    var downloadBanner = document.querySelector("closeButton-3cJIM4");
    
    if (dismissButton) {
        dismissButton.click();
    }
    if (downloadButton) {
        downloadButton.parentNode.removeChild(downloadButton);
    }
    if (downloadBanner) {
        downloadBanner.click();
    }
}

function countMethod() {
    var count = 0;
    var countList = document.querySelectorAll("div.numberBadge-37OJ3S.base-3IDx3L.baseShapeRound-3epLEv");
    //var countList = document.querySelectorAll("div.badge-1GsMF2");
    if (countList.length > 0) {
        alert("count 1" + count);
        var i;
        for (i = 0; i < countList.length; i++) {
            count = count + parseInt(countList[i].textContent);
            alert("count 2" + count);
        }
        unreadCount = count;
        
    } else {
        //        if(unreadCount != 0)
        //        {
        unreadCount = 0;
        //            webkit.messageHandlers.notification.postMessage(["Discord","count","DiscordCount",0]);
        
        //        }
    }
    if (dockCounterDiscord != unreadCount) {
        webkit.messageHandlers.notification.postMessage(["Discord", "count", "DiscordCount", unreadCount]);
        dockCounterDiscord = unreadCount;
    }
}

$(window).blur(function() {
    
    focusblur = "blured";
    
});
$(window).focus(function() {
    focusblur = "focused";
    
});


jQuery(document).on('click', 'input[type="file"]', function() {
    if (showMediaUploadAlert) {
        confirm('To upload media, drag and drop the file into the One Chat window.');
    }
});

jQuery(document).mouseenter(function() {
    //addReadAllNotification();
    alert("mouseenter");
    if (!isLinkAttached) {
        attachAppLink();
    }
});




function spellCheckerOff(box) {
    if (box.value.length >= 1 && box.value.length < 5) {
        //box.setAttribute("spellcheck",false);
    }
}
//--------------------------------------------------------
//@New Conversation and Logout
//--------------------------------------------------------
function newConversation() {
    
    var searchButton = document.querySelector('.input-1Rv96N');
    if (searchButton) {
        var evt = document.createEvent("Events");
        evt.initEvent("focus", true, true);
        searchButton.focus();
        searchButton.dispatchEvent(evt);
    }
}

function logout() {
    var userSettingButton = document.querySelector('[aria-label="User Settings"]');
    if (userSettingButton) {
        userSettingButton.click();
        setTimeout(function() {
            var leftPanel = document.querySelectorAll('.item-PXvHYJ');
            var logoutButton = leftPanel[leftPanel.length - 1];
            if (logoutButton) {
                logoutButton.click();
                setTimeout(function() {
                    var overlayLogoutButton = document.querySelector('button[type="submit"]');
                    if (overlayLogoutButton) {
                        overlayLogoutButton.click();
                    }
                }, 600);
            }
        }, 200);
    }
    
}



function addReadAllNotification() {
    //    if(document.querySelector('div.friends-icon'))
    //    {
    //        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
    //        return true;
    //    }
    //    else
    //    {
    //        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
    //        return false;
    //    }
}
//
function readAllMessages() {
    //    var chatList = $('.guild');
    //
    //    (function myLoop (i) {
    //        if(chatList[i-1].querySelector('.badge'))
    //        {
    //            setTimeout(function ()
    //                       {
    //                nodeToBeClicked = chatList[i-1];
    //                prompt("openwhatsappchat");//  your code here
    //                if (--i) myLoop(i);      //  decrement i and call myLoop again if i > 0
    //            },0);
    //        }
    //        else
    //        {
    //            if (--i) myLoop(i);
    //        }
    //    })(chatList.length);
}

function openGivenChat() {
    //    nodeToBeClicked.querySelector('.guild-inner a').click();
}

//=========================================
//@Auto Login Handlers
//=========================================
function clickLoginButton(formNode) {
    if (formNode) {
        clickNode('button[type="submit"]');
    }
}


//=========================================
//@Message Scheduler
//=========================================
//privateChannels-oVe7HL

jQuery(document).on('click', '.sidebar-1tnWFu', function() {
    addScheduler();
    // $(TEXTBOXSL).attr("spellcheck","true");
    
});

jQuery(document).on('click', 'a[role="listitem"]', function() {
    addScheduler();
    // $(TEXTBOXSL).attr("spellcheck","true");
    
});


function addScheduler() {
    alert("addScheduler");
    isLinkAttached = false;
    var channelButton = document.querySelector("section.title-31SJ6t.container-ZMc96U.themed-Hp1KC_");
    var nameOfUser = document.querySelector('#app-mount > div.app-1q1i1E > div > div.layers-3iHuyZ.layers-3q14ss > div > div > div > div.content-98HsJk > div.chat-3bRxxu > section > div.children-19S4PO > h3');
    if (nameOfUser) {
        
        TEXTBOXSL = 'div[aria-label="Message @' + nameOfUser.textContent.trim() + '"]';
    }
    
    
    if (channelButton) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;
        
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {
    
    var userElement = document.querySelector("#app-mount > div.app-1q1i1E > div > div.layers-3iHuyZ.layers-3q14ss > div > div > div > div.content-98HsJk > div.chat-3bRxxu > section > div.children-19S4PO > h3");
    setTimeout(function() {
        alert("schedule");
        userElement = document.querySelector("h3.cursorPointer-3JF56F.title-17SveM.base-ZDDK0g.size16-CysEuG");
        if (userElement) {
            alert("userElement");
            var username = userElement.textContent;
            if (username) {
                alert("username");
                username = username.trim(); //replace(/\s/g,' ').
                webkit.messageHandlers.notification.postMessage(["schedulemessage", username, "", ""]);
            } else {
                alert("!username");
            }
        } else {
            openChatAlert();
        }
    }, 1000);
    
}


//=========================================
//@Reply from Notification
//=========================================
function replyForNotification(useridSL, replymsgSL) {
    alert(useridSL + " " + replymsgSL);
    var i;
    var displ = document.querySelectorAll("#app-mount > div.appDevToolsWrapper-1QxdQf > div > div.app-3xd6d0 > div > div.layers-OrUESM.layers-1YQhyW > div > div.container-1eFtFS > div > div.content-1SgpWY > div.sidebar-1tnWFu > nav > div.scroller-WSmht3.thin-31rlnD.scrollerBase-_bVAAt.fade-1R6FHN > ul > li");
    var channelId = 0;
    //    alert(displ.length);
    for (i = 0; i < displ.length; i++) {
        var node = displ[i];
        var userNameTag = node.querySelector("div.interactive-1vLZ_I.interactive-iyXY_x  > a");
        //        alert(userNameTag);
        if (userNameTag) {
            //            alert(userNameTag);
            var tempun = userNameTag.getAttribute("aria-label");
            //            alert(tempun);
            if (tempun) {
                if (useridSL.trim().indexOf(tempun.replace("(direct message)", "").trim()) != -1) {
                    userNameTag.click();
                    var textEvent = document.createEvent('TextEvent');
                    textEvent.initTextEvent('textInput', true, true, window, replymsgSL, 0, "en-US");
                    TEXTBOXSL = 'div[aria-label="Message @' + useridSL.trim() + '"]';
                    document.querySelector(TEXTBOXSL).focus();
                    document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
                    setTimeout(function(e) {
                        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
                        
                    }, 200);
                    break;
                }
            }
            
        } else if (i == displ.length - 1) {
            self.searchUserAndReply(useridSL, replymsgSL);
        }
    }
}

function searchUserAndReply(useridSL, replymsgSL) {
    var findFriendsSearch = document.querySelector("#app-mount > div.appDevToolsWrapper-1QxdQf > div > div.app-3xd6d0 > div > div.layers-OrUESM.layers-1YQhyW > div > div.container-1eFtFS > div > div.content-1SgpWY > div.sidebar-1tnWFu > nav > div.searchBar-3TnChZ > button");
    
    if (findFriendsSearch) {
        findFriendsSearch.click();
        setTimeout(function(e) {
            var inputSearch = document.querySelector('input[aria-label="Quick switcher"]');
            if (inputSearch) {
                inputSearch.setAttribute("value", useridSL);
                setTimeout(function(e) {
                    var results = document.querySelector('div[role="listbox"]');
                    var j = 0;
                    if (results) {
                        var userNameTags = results.querySelectorAll('div[role="option"]');
                        for (j = 0; j < userNameTags.length; j++) {
                            var userNameTag = userNameTags[j].querySelector("span");
                            if (userNameTag) {
                                alert(userNameTag);
                                if (userNameTag.indexOf(useridSL.trim()) != -1) {
                                    //                                    alert("MAtched");
                                    userNameTags[j].click();
                                    
                                    TEXTBOXSL = 'div[aria-label="Message @' + useridSL.trim() + '"]';
                                    setTimeout(function(e) {
                                        var textEvent = document.createEvent('TextEvent');
                                        textEvent.initTextEvent('textInput', true, true, window, replymsgSL, 0, "en-US");
                                        document.querySelector(TEXTBOXSL).focus();
                                        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
                                        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
                                        
                                    }, 500);
                                    
                                }
                            }
                        }
                    } else {
                        alert("No Such Results");
                        return;
                    }
                }, 500);
            }
        }, 200);
    }
}

function attachAppLink() {
    //    alert("attachAppLink");
    
    var nameOfUser = document.querySelector('#app-mount > div.appDevToolsWrapper-1QxdQf > div > div.app-3xd6d0 > div > div.layers-OrUESM.layers-1YQhyW > div > div.container-1eFtFS > div > div > div.chat-2ZfjoI > section > div.children-3xh0VB > h3');
    if (nameOfUser) {
        TEXTBOXSL = 'div[aria-label="Message @' + nameOfUser.textContent.trim() + '"]';
        webkit.messageHandlers.notification.postMessage(["userChecker", "Discord", nameOfUser.textContent.trim()]);
    }
    
}


function callBackForLinKAttach(msgText) {
    //    alert("callBackForLinKAttach");
    if (!isLinkAttached) {
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
        //    textEvent.initTextEvent('textInput', true, true, null, "Sent using \"One Chat\" - http://bit.ly/OneChatApp", 9, "en-US");
        document.querySelector(TEXTBOXSL).focus();
        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
        isLinkAttached = true;
        setTimeout(function(e) {
            
                setTimeout(function() {
                    addLayerObserver();
                    //if (document.querySelector(TEXTBOXSL).length > 0) {
                        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
                    //}
                }, 200);

        }, 2000);
    }
}

function __triggerKeyboardEvent(el, keyCode, meta) {
    var eventObj = document.createEventObject ?
    document.createEventObject() : document.createEvent("Events");
    
    if (eventObj.initEvent) {
        eventObj.initEvent("keydown", true, true);
    }
    
    eventObj.keyCode = eventObj.which = keyCode;
    if (meta) {
        eventObj.metaKey = true;
    }
    
    el.dispatchEvent ? el.dispatchEvent(eventObj) : el.fireEvent("onkeydown", eventObj);
}
