var mutationObserverBool = false;
var unreadCountRef = 0;
jQuery.noConflict();
var $ = jQuery;
var TEXT_BOX = 'textarea.sc-lhVmIH.jCVyZK';
var SEND_BTN = 'div.sc-fOKMvo.eWXVMG';
var nodeToBeClicked = "";
var isLinkAttached = false;

//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function (title, options)
{
    alert("NOTIF RECEIVED");
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};

function newConversation()
{
    clickNode('#add-convo img');
}

function logout()
{
    clickNode('#left_pane_account');
    var testNode = document.querySelector('.menu.right div.item:last-child a');
    testNode.click();
    setTimeout(function()
               {
        var signoutButton = document.querySelectorAll('.panel.fading.sliding.in.confirmation-overlay .center button')[0];
        signoutButton.click();
    },200);
}

$(document).ready(function()
                  {
    removeNode('#landing-footer-bg');
    removeNode('#landing_header_area');
    
});
$(document).on('click', 'input[type="file"]', function () {
    
    if(!verGreaterThanTwelve)
    {
        confirm('To upload media, drag and drop the file into the One Chat window.');
    }
});

jQuery(window).load(function ()
                    {
    setTimeout(mutationObserverHandler,10000);
    setTimeout(mutationObserverHandler,15000);
    setInterval(regularCountUpdater,1000);
    setTimeout(addReadAllNotification,10000);
    setTimeout(addReadAllNotification,5000);
    setTimeout(addReadAllNotification,15000);
    setInterval(addScheduler,1000);
    
});

$(document).mouseenter(function(){
    addScheduler();
    addReadAllNotification();
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
});

jQuery(document.body).on('click', SEND_BTN, function(e) {
    //    alert("click_SEND_BTN");
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
    webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
});


jQuery(document.body).on('keyup', TEXT_BOX, function(e) {
    
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
    } else {
        isLinkAttached = false;
    }
});

function mutationObserverHandler()
{
    addScheduler();
    if(mutationObserverBool)
    {
        return;
    }
    var target = document.querySelector('div.conversations');
    var observer = new MutationObserver(function(mutations)
                                        {
        mutations.forEach(function(mutation)
                          {
            var userName = "";
            var userText = "";
            
            if(mutation.target.getAttribute("class").indexOf("conversation unread")!=-1)
            {
                userName = mutation.target.querySelector('div.label').textContent;
                
                webkit.messageHandlers.notification.postMessage(["Fleep",userName,"New Message Received",getTotalUnreadCount(),""]);
            } else {
                if(mutation.type == "attributes"){
                    
                    if(mutation.target.getAttribute("class") == "unread-count"){
                        userName = mutation.target.parentNode.parentNode.querySelector('div.label').textContent;
                        webkit.messageHandlers.notification.postMessage(["Fleep",userName,"New Message Received",getTotalUnreadCount(),""]);
                    }
                }
            }
        });
    });
    
    var config = {childList: true, attributes: true, characterData: true, subtree:true};
    
    if(!mutationObserverBool){
        if(target){
            observer.observe(target, config);
            mutationObserverBool = true;
        }
    }
}

function getTotalUnreadCount(){
    var tempCount = 0;
    var countNodeList =  $('.conversation.unread .unread-count.sc-dnqmqq.fkYYgB');
    if(countNodeList){
        for(var i = 0; i< countNodeList.length; i++){
            tempCount = tempCount + parseInt(countNodeList[i].textContent);
        }
    }
    return tempCount;
}

function regularCountUpdater(){
    var count = 0;
    count = getTotalUnreadCount();
    if(count != unreadCountRef){
        webkit.messageHandlers.notification.postMessage(["Fleep","count","FPCount",count,null]);
        unreadCountRef = count;
    }
}

//--------------------------------------------
//Guggy stickers Handlers
//--------------------------------------------
function addCustomEmoji(){
    if($('.message_entry .button-circle').length){
        prompt ("attachGif");
        $('.message_entry .button-circle').click();
        var plusButton = document.querySelector('div.menu.right .item:last-child a');
        plusButton.click();
    } else {
        selectAChatAlert();
    }
}

function sentenceForGuggyStickerSearch(){
    var sentence = "";
    if(document.querySelector(TEXT_BOX)){
        sentence =  document.querySelector(TEXT_BOX).value;
    }
    return sentence;
}

jQuery(document.body).on('keyup',TEXT_BOX,function (e){
    if(this.value.length>=1 && this.value.length<5){}
    var rect = document.querySelector(TEXT_BOX).getBoundingClientRect();
    if(e.which === 32) {
        var numberOFWords = (document.querySelector(TEXT_BOX).value.match(new RegExp(" ", "g")) || []).length;
        if(numberOFWords>=0){
            if(verGreaterThanTwelve){
                webkit.messageHandlers.notification.postMessage(["enableStickersButton","on", rect.bottom,rect.right]);
            }
        }
    }
    if(e.which === 13){
        webkit.messageHandlers.notification.postMessage(["enableStickersButton","off"]);
    }
    if(document.querySelector(TEXT_BOX).value.length==3){
        if(verGreaterThanTwelve){
            webkit.messageHandlers.notification.postMessage(["enableStickersButton","on", rect.bottom,rect.right]);
        }
    }
    
    if( e.which === 8 || e.which === 46 ){
        if(document.querySelector(TEXT_BOX).value.length<3){
            webkit.messageHandlers.notification.postMessage(["enableStickersButton","off"]);
        }
    }
});

//--------------------------------------------
// Message Scheduling Handlers
//--------------------------------------------

function addScheduler(){
    if($('.header_area .fl-editable-text').length){
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus","off"]);
        return false;
    }
}

function schedule(){
    setTimeout(function(){
        var nameOfUser = $('.conversations .conversation.selected .label');
        if(nameOfUser.length){
            var imgURL = "";
            var avatar = document.querySelector('.conversations .conversation.selected .avatar-image');
            if(avatar){
                var img = avatar.style.backgroundImage;
                imgURL = img.substring(4, img.length-1);
                webkit.messageHandlers.notification.postMessage(["schedulemessage",nameOfUser.text(),"",imgURL]);
            } else {
                webkit.messageHandlers.notification.postMessage(["schedulemessage",nameOfUser.text()]);
            }
        } else{
            openChatAlert();
        }
    },0);
}

$(document).on('click','.body .conversations', function(){
    addScheduler();
});

function replyForNotification(userid, replymsg){
    var userList = document.querySelectorAll('.conversations .conversation');
    if(userList.length<0){
        return;
    } else {
        var j;
        for(j=0;j<userList.length;j++) {
            var individualName = userList[j].querySelector('.label').textContent;
            if(individualName.indexOf(userid)!=-1){
                userList[j].click();
                setTimeout(function(){
                    var textEvent = document.createEvent('TextEvent');
                    textEvent.initTextEvent('textInput', true, true, null, replymsg, 9, "en-US");
                    document.querySelector(TEXT_BOX).dispatchEvent(textEvent);
                    __triggerKeyboardEvent(document.querySelector(TEXT_BOX),13,true);
                }, 200);
            }
        }
    }
}

function addReadAllNotification(){
    if(document.querySelector('#left_pane_account')){
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
        return true;
    }  else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
        return false;
    }
}

function readAllMessages(){
    var chatList = $('.conversation.unread');
    
    (function myLoop (i) {
        setTimeout(function (){
            nodeToBeClicked = chatList[i-1];
            prompt("openwhatsappchat");//  your code here
            if (--i) myLoop(i);      //  decrement i and call myLoop again if i > 0
        },350);
    })(chatList.length);
}

function openGivenChat(){
    nodeToBeClicked.click();
}

//=========================================
//@Auto Login Handlers
//=========================================
function clickLoginButton(formNode){
    clickNode('[type="submit"]');
}

function toDataUrl(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.responseType = 'blob';
    xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
            callback(reader.result);
        };
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.send();
}

//=========================================
//@Message Scheduler
//=========================================

function addScheduler() {
    if ($('#app > div > div > div > div.chat_main_area > div > div.sc-dxZgTM.cjjFnw > div.sc-iomxrj.kmAUWl > div.sc-iFMziU.hjWAhq').length) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {
    scheduleMessageForUser();
}

function scheduleMessageForUser() {
    setTimeout(function() {
        var nameOfUser = document.querySelector('#app > div > div > div > div.chat_main_area > div > div.sc-dxZgTM.cjjFnw > div.sc-iomxrj.kmAUWl > div.sc-iFMziU.hjWAhq');
        if (nameOfUser.textContent) {
            var userid = "";
            var imgURL = "";
            
            if ($('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6')) {
                imgURL = $('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6').attr("src");
            }
            
            webkit.messageHandlers.notification.postMessage(["schedulemessage", nameOfUser.textContent, "", imgURL]);
        } else {
            openChatAlert();
        }
    }, 10);
}

function replyForNotification(userid, replymsg) {
    searchUserAndReply(userid, replymsg);
}


function searchUserAndReply(useridTG, replymsgTG) {
    var username = document.querySelector('div[title="'+useridTG+'"]');
    if (username) {
        username.click();
        
        setTimeout(function() {
            alert("insertMessage(replymsgTG);");
            insertMessage(replymsgTG);
            setTimeout(function() {
                alert("triggerClick");
                triggerClick();
            }, 200);
            
        }, 500);
    }  else {
        insertSearch(useridTG);
        setTimeout(function() {
            
            setTimeout(function() {
                alert("insertSearch");
                var username = document.querySelector('div.search-result > div > div > div.conversation.focused.selected > div.label > div.topic');
                if(username){
                    alert("search[0].click()");
                    var sevent = new MouseEvent('mousedown', {
                        'view': window,
                        'bubbles': true,
                        'cancelable': true
                    });
                    username.dispatchEvent(sevent);
                    setTimeout(function() {
                        alert("insertMessage(replymsgTG);");
                        insertMessage(replymsgTG);
                        setTimeout(function() {
                            alert("triggerClick");
                            triggerClick();
                        }, 200);
                        
                    }, 500);
                }
                
            }, 500);
        }, 2000);
    }
}


function insertMessage(message) {
    alert("insert message");
    var textField = document.querySelector(TEXT_BOX);
    if (!textField) {
        alert("textField is null");
    }
    dispatch(textField, "textInput", message);
}

function triggerClick() {
    var button = document.querySelectorAll(SEND_BTN);
    if (button.length > 0) {
        var i = 0;
        for(i < 0; i< button.length; i++){
            if((button[i].textContent.indexOf("Send") != -1)){
                button[i].click();
            }
        }
    }
}

function insertSearch(searchText) {
    var searchbox = document.querySelectorAll('input[placeholder="Search"]');
    if(searchbox.length > 0){
        alert("insert message");
        searchbox[1].click();
        searchbox[1].focus();
        
        setTimeout(function() {
            alert("dispatchEvent");
            var textEvent = document.createEvent('TextEvent');
            textEvent.initTextEvent('textInput', true, true, null, searchText, 9, "en-US");
            
            searchbox[1].dispatchEvent(textEvent);
            searchbox[1].textContent = "";
            searchbox[1].textContent = searchText;
            setTimeout(function() {
                var event = new MouseEvent('mousedown', {
                    'view': window,
                    'bubbles': true,
                    'cancelable': true
                });
                searchbox[1].dispatchEvent(event);
                if(searchbox.length > 0){
                    __triggerKeyboardEvent(searchbox[1], 13, true);
                }
            }, 200);
        }, 1000);
    }
}

function __triggerKeyboardEvent(el, keyCode, meta) {
    var eventObj = document.createEventObject ?
    document.createEventObject() : document.createEvent("Events");
    if (eventObj.initEvent) {
        eventObj.initEvent("keydown", true, true);
    }
    eventObj.keyCode = eventObj.which = keyCode;
    if (meta) {
        eventObj.metaKey = true;
    }
    var i = el.dispatchEvent ? el.dispatchEvent(eventObj) : el.fireEvent("onkeydown", eventObj);
}

function dispatch(target, eventType, char) {
    var evt = document.createEvent("TextEvent");
    evt.initTextEvent(eventType, true, true, window, char, 0, "en-US");
    target.focus();
    target.dispatchEvent(evt);
    setTimeout(function() {
        setTimeout(function() {
        }, 200);
    }, 1000);
}


//-------------------------------------------------------
//@Sent From One Chat Link Attachment Handler
//-------------------------------------------------------
function attachAppLink() {
    var nameOfUser = document.querySelector('#app > div > div > div > div.chat_main_area > div > div.sc-dxZgTM.cjjFnw > div.sc-iomxrj.kmAUWl > div.sc-iFMziU.hjWAhq').textContent;
    webkit.messageHandlers.notification.postMessage(["userChecker", "Fleep", nameOfUser]);
}

function callBackForLinKAttach(messageText) {
    if (!isLinkAttached) {
        dispatch(document.querySelector(TEXT_BOX), 'textInput', messageText);
        isLinkAttached = true;
        triggerClick();
    }
}

function callBackForLinkAttachment(url) {
    var msg = "\nSent using \"One Chat\" - " + url;
    dispatch(document.querySelector(TEXT_BOX), 'textInput', msg);
    triggerClick();
}

