var messagechecker;
var showMediaUploadAlert = true;

if(navigator.appVersion.indexOf("10_11") > -1) {
    showMediaUploadAlert = true;
}
else {
    showMediaUploadAlert = false;
}

//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function (title, options)
{
    alert("NOTIF RECEIVED");
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};


//--------------------------------------------
//@Event Listeners
//--------------------------------------------

jQuery(document).on('click', 'div.Zm-ty div div.a-b-c.d-u.d-u-Q', function ()
                    {
                    if(showMediaUploadAlert)
                    {
                    confirm('To upload media, drag and drop the file into the One Chat window.');
                    }
                    });

jQuery(document).on('click', 'div[aria-label="Start phone call"]', function (e)
                    {
    
    confirm('Hangouts Audio/Video calling is currently not supported by the app. Inconvenience is regretted.');
    
});
jQuery(document).on('click', 'div[aria-label="Phone Calls"]', function (e)
                    {
    
    confirm('Hangouts Audio/Video calling is currently not supported by the app. Inconvenience is regretted.');
    
});

jQuery(document).on('keyup','[role="textbox"]',function()
                    {
                    if(this.textContent.length>=1 && this.textContent.length<5)
                    {
                        //this.setAttribute("spellcheck",false);
                    }
                    });

$(document).mouseenter(function()
                         {
                            webkit.messageHandlers.notification.postMessage(["Hangouts","count","HOCount",0]);
                         });

$(document).ready(function()
                       {
                  
                       });

function addObservers() {
    addBodyObserver();
}

var shouldAddBodyObserver = true;
function addBodyObserver() {
    var target = document.querySelector("body");
    //alert("body observer "+target);
    if(target) {
        if(shouldAddBodyObserver) {
            var observer = new MutationObserver(function(mutations) {
                                                mutations.forEach(function(mutation) {
                                                                  //alert("body mutation "+mutation.type);
                                                                  removeElements();
                                                                  });
                                                });
            
            var config = {attributes:true, childList:true, characterData:true, subtree:true};
            observer.observe(target, config);
            alert("body Observer Added");
            shouldAddBodyObserver = false;
        }
    }
    else {
        setTimeout(function(){
                   addBodyObserver();
                   }, 2000);
    }
}
function removeElements() {
    //alert("remove elements");
    
    var menuElement = document.querySelector("div.rxXpLd");
    if(menuElement) {
        menuElement.style.display = "none";
    }
    
    var appsElement = document.querySelector("div#gbwa");
    if(appsElement) {
        appsElement.style.display = "none";
    }
    
    var moreElement = document.querySelector("div[aria-label=More]");
    if(moreElement) {
        moreElement.style.display = "none";
    }
}

//--------------------------------------------------------
//@New Conversation and Logout
//--------------------------------------------------------

function newConversation()
{
    var plusButton = document.querySelector('body div div iframe.Xyqxtc').contentDocument.querySelector('button.Izwf5d.ptrgQb.zv8lsd.fTj9Ab');
    if(plusButton)
    {
        plusButton.click();
    }
}


//--------------------------------------------------------
//@Auto Login Handlers
//--------------------------------------------------------
function submitUserName(userName)
{
    var userNameField;
    userNameField = getUserNameField(document);
    if(userNameField)
    {
        userNameField.value = userName;
        
        if(document.querySelector('#signIn'))
        {
            document.querySelector('#signIn').click();
        }
        else
        {
            if(document.querySelector('#identifierNext'))
            {
                document.querySelector('#identifierNext').click();
            }
        }
    }
}

function submitPassword(passWord)
{
    var passWordField;
    passWordField = getPassWordField();
    if(passWordField)
    {
        passWordField.value = passWord;
        
        if(document.querySelector('#signIn'))
        {
            document.querySelector('#signIn').click();
        }
        else
        {
            if(document.querySelector('#passwordNext'))
            {
                document.querySelector('#passwordNext').click();
            }
        }
    }
}

function logout()
{
    document.querySelectorAll('div a[role="button"]')[2].click();
    document.querySelector('a#gb_71').click();
}


function clickmessagebutton()
{
    if(document.querySelector('body div div iframe.Xyqxtc'))
    {
      return;  
    }
    
    var messagebutton = document.querySelectorAll('ul li div.mUbCce.fKz7Od.g-Ue-b.g-Ue-ua-b');
    if(messagebutton)
    {
        messagebutton[2].click();
    }
    
    setTimeout(function()
    {
        document.querySelectorAll('div div.mUbCce.fKz7Od.cTIldc.jOetNc')[1].click();
    },3000);
}
function clickOnContacts() {
    //alert("Click Conv");
    var convElement = document.querySelector("div[aria-label=Conversations]");
    if(convElement) {
        //alert("conv clicked");
        convElement.click();
    }
}

function removegooglelogo()
{
    setTimeout(function()
    {
    var glogo = document.querySelector('div.logo.logo-w');
    if(glogo)
        glogo.parentNode.removeChild(glogo);
    var heading = document.querySelector('div.main.content.clearfix div.banner h1');
    if(heading)
        heading.innerHTML="Hangouts";
    },0);
}

function eventlstenercount()
{
    setTimeout(clickmessagebutton,5000);
    
    setTimeout(function()
               {
               var element = document.querySelector("body div div iframe.Xyqxtc");
               if(element) {
               var checkelement = element.contentDocument;
               
               if(checkelement)
               {
               checkelement.addEventListener("click", function()
                                             {
                                             
                                             webkit.messageHandlers.notification.postMessage(["Hangouts","count","HOCount",0]);
                                             });
               
               
               document.addEventListener("click", function()
                                         {
                                         
                                         webkit.messageHandlers.notification.postMessage(["Hangouts","count","HOCount",0]);
                                         });
               }
               else
               {
               eventlstenercount();
               }
               }
               },11000);
    
}

function myeventfunctionHO()
{
    dockcountHO();
}

function dockcountHO()
{

    var userandmsg =  document.querySelector('body div div iframe.Xyqxtc').contentDocument.getElementsByClassName ("gS5QBe R8jgRe")[0];
    var usernameHO = userandmsg.getElementsByClassName("lt mG mG")[0].textContent;
    
    var textmsgHO = userandmsg.getElementsByClassName("ng sQR2Rb")[0].textContent;
    if (textmsgHO.indexOf("You: ") != -1 || textmsgHO.indexOf("Invitation sent") != -1  )
    {
        return
    }
    if(textmsgHO)
    {}
    else
        return;

if(messagechecker!= usernameHO+textmsgHO)
{
    webkit.messageHandlers.notification.postMessage(["Hangouts",usernameHO,textmsgHO,0]);
    messagechecker=usernameHO+textmsgHO;
}
}

function clickaccountspage()
{
    document.getElementsByClassName("gb_b gb_Vb").click();
    document.getElementsByClassName("gb_ka gb_Je").click();
}

//--------------------------------------------------------
//@Reply For Notification
//--------------------------------------------------------
function replyForNotification(useridSL, replymsgSL)
{
    var i;
    var displ = document.querySelector('body div div iframe.Xyqxtc').contentDocument.getElementsByClassName ("gS5QBe R8jgRe");
    for(i=0; i < displ.length; i++)
    {
        var tempun = displ[i].getElementsByClassName("lt mG mG")[0].textContent;
        if (tempun.indexOf(useridSL) != -1)
        {
            displ[i].click();
            i = displ.length+3;
            
            setTimeout(function(){
            var chatboxchk = document.querySelectorAll('div.Cl iframe');
            for(i=0; i < chatboxchk.length; i++)
            {
            var chatbox = document.querySelectorAll('div.Cl iframe')[i].contentDocument.querySelector('div.Ob2Lud.RE.EIhiV').textContent;
           
                if (chatbox.indexOf(useridSL) != -1)
                {
           var chatboxtextfield = document.querySelectorAll('div.Cl iframe')[i].contentDocument.querySelector('div.vE.dQ');
                       
                       var textEvent = document.createEvent('TextEvent');
                       textEvent.initTextEvent('textInput', true, true, null, replymsgSL, 9, "en-US");
                     
                      chatboxtextfield.dispatchEvent(textEvent);
                       textEvent.initTextEvent('textInput', true, true, null, " ", 9, "en-US");
                       
                       
                       chatboxtextfield.dispatchEvent(textEvent);
                       setTimeout(function()
                        {
                   __triggerKeyboardEvent(chatboxtextfield,13,true);
                                  setTimeout(function()
                                             {
                                             __triggerKeyboardEvent(chatboxtextfield,13,true);
                                             
                                             
                                             document.querySelectorAll('div.Cl iframe')[i].contentDocument.querySelector('button.gGnOIc.tV.qp.SD.p7oPo.JPiKic').click();
                                            
                                             },1000);
                        },500);
                       
                       return;
                }
            }
                        },300);
                    
        }
        
    }
}

function readAllMessages()
{
    
}
