var verGreaterThanEleven = false;
var verGreaterThanTwelve = false;
var PASSWORD_FIELD = 'input[type= "password"]';
var awesomplete;

function setOSVersion(verEleven, verTwelve) {
    verGreaterThanEleven = verEleven;
    verGreaterThanTwelve = verTwelve;
}

function selectAChatAlert() {
    confirm("Select a Chat to Send GIF..");
}

function openChatAlert() {
    confirm("Open a chat to schedule message..");
}

function showDragDropAlert() {
    confirm('To upload media, drag and drop the file into the One Chat window.');
}

function removeNode(elementPointer) {
    if ($(elementPointer).length) {
        $(elementPointer).remove();
        return true;
    } else {
        return false;
    }
}

function clickNode(elementPointer) {
    if ($(elementPointer).length) {
        $(elementPointer).click();
    }
}

//function showTextContent(elementPointer)
//{
//    if($(elementPointer).length)
//    {
//        alert($(elementPointer).text());
//    }
//}

function triggerMouseEvent(node, eventType) {
    var clickEvent = document.createEvent('MouseEvents');
    clickEvent.initEvent(eventType, true, true);
    node.dispatchEvent(clickEvent);
}

function __triggerKeyboardEvent(el, keyCode, meta) {
    var eventObj = document.createEventObject ?
        document.createEventObject() : document.createEvent("Events");

    if (eventObj.initEvent) {
        eventObj.initEvent("keydown", true, true);
    }

    eventObj.keyCode = eventObj.which = keyCode;
    if (meta) {
        eventObj.metaKey = true;
    }

    var exp = el.dispatchEvent ? el.dispatchEvent(eventObj) : el.fireEvent("onkeydown", eventObj);
}

function passWordFieldChecker() {
    if (window.jQuery) {
        var $ = jQuery;
        if ($(PASSWORD_FIELD).length) {
            return true;
        }
    } else {
        if (document.querySelector(PASSWORD_FIELD)) {
            return true;
        }
    }
    return false;
}

function performAutoLoginWithUserDetails(userName, passWord) {

    autoLoginWithUserDetails(userName, passWord);
    var passWordInputField = getPassWordField();
    var userNameInputField;
    var formNode;
    if (passWordInputField) {
        formNode = getFormNode(passWordInputField);
        if (formNode) {
            userNameInputField = getUserNameField(formNode);
            passWordInputField.value = passWord;
            userNameInputField.value = userName;
            setTimeout(function() {
                clickLoginButton(formNode);
            }, 1000);
        }
    } else {

    }


}

//-----------------------------------------------------------
//@Getter for UserNameField, PasswordField, FormNode...
//-----------------------------------------------------------
function getUserNameField(formNode) {
    if (!formNode) {
        formNode = document;
    }

    return formNode.querySelector('input#email') || formNode.querySelector('input#emailOrUsername') || formNode.querySelector('input[type="email"]') || formNode.querySelector('input[name="email"]') || formNode.querySelector('input[name="Email"]') || formNode.querySelector('form input.js-username-field') || formNode.querySelector('form input#login-username') || formNode.querySelector('input[name="username"]') || formNode.querySelector('input[name="login"]');
    //    || formNode.querySelector('input[type="text"]');

}

function getPassWordField() {
    var passWordInputFieldList = document.querySelectorAll(PASSWORD_FIELD);
    var passWordInputField;
    if (passWordInputFieldList.length > 1) {
        passWordInputField = passWordInputFieldList[1];
    } else {
        passWordInputField = passWordInputFieldList[0];
    }
    return passWordInputField;
}

function getFormNode(passWordNode) {
    var formNode = findFormParentNode(passWordNode);
    if (!formNode) {
        if (document.querySelector('div#main_form')) {
            formNode = document.querySelector('div#main_form');
        } else {
            return;
        }
    }
    return formNode;
}



function identifyLoginPage() {
    setTimeout(function() {
        var passWordField = getPassWordField();
        var formNode;
        var userNameField;

        if (passWordField) {

            monitorUserNameAndPasswordInput(passWordField);

            formNode = getFormNode(passWordField);
            if (formNode) {
                userNameField = getUserNameField(formNode);
                if (userNameField) {

                    loginPageIntimation(userNameField);
                    if (document.querySelector('#identifierNext')) {
                        document.querySelector('#identifierNext').addEventListener("click", function() {
                            loginMonitorForHangouts();

                        });
                        userNameField.addEventListener("keyup", function(e) {
                            if (e.which === 13) {
                                loginMonitorForHangouts();
                            }
                        });
                    }

                }

            }
        } else {
            userNameField = getUserNameField(document);
            if (userNameField) {
                if (userNameField.hasAttribute("type")) {
                    if (userNameField.getAttribute("type") == "hidden") {
                        return;
                    }
                }
                formNode = getFormNode(userNameField);
                if (formNode) {
                    //loginPageIntimation(userNameField);
                }
            }
        }

    }, 200);
}

function loginMonitorForHangouts() {
    setTimeout(function() {
        var passWordField = getPassWordField();
        if (passWordField) {
            monitorUserNameAndPasswordInput(passWordField);
        }
    }, 3000);
}

function loginPageIntimation(userNameField) {

    awesomplete = new Awesomplete(userNameField, {
        minChars: 0,
        autoFirst: true,
    });

    //    if(document.querySelector('.placeholderContainer'))
    //    {
    //        document.querySelector('.placeholderContainer').addEventListener("click", function(e)
    //                                                                         {
    //
    //                                                                         displayUserAccountsList(e.target);
    //
    //                                                                         });
    //    }

    //    userNameField.addEventListener("awesomplete-selectcomplete", function (e)
    //     {
    window.webkit.messageHandlers.autologin.postMessage(["autologinwithgivenaccount", e.text]);

    //    });

    userNameField.addEventListener("click", function(e) {
        displayUserAccountsList(e.target);

    });



    //    userNameField.addEventListener("keyup", function(e)
    //                                   {
    //                                   displayUserAccountsList(e.target);
    //                                   });
}

function setListofUseraccounts(accounts) {
    var jsonString = atob(accounts);
    var accountsArray = JSON.parse(jsonString);
    awesomplete.list = accountsArray;
    awesomplete.evaluate();
    awesomplete.open();
}

function displayUserAccountsList(userNameField) {
    window.webkit.messageHandlers.autologin.postMessage(["displayusercredentials", "Message"]);
}

function storeLoginDetails(username, password) {
    window.webkit.messageHandlers.autologin.postMessage(["storeusercredentials", username, password]);
}

function monitorUserNameAndPasswordInput(passWordField) {
    var loginButton;

    var formNode = getFormNode(passWordField);

    //for messenger :- loginButton
    if (document.querySelector('#idSIButton9')) {
        document.querySelector('#idSIButton9').addEventListener("click", retieveLoginDetails);
        listenToPasswordFieldKeyUp(passWordField);
    }

    if (formNode) {


        if (document.querySelector('a.button-fleep.fleep-blue')) {
            document.querySelector('a.button-fleep.fleep-blue').addEventListener("click", retieveLoginDetails);
            listenToPasswordFieldKeyUp(passWordField);
        } else {
            if (passWordField.hasAttribute("id") && passWordField.getAttribute("id") == "login-passwd") {

                listenToPasswordFieldKeyUp(passWordField);
            } else {
                if (document.querySelector('#passwordNext')) {
                    listenToPasswordFieldKeyUp(passWordField);
                    document.querySelector('#passwordNext').addEventListener("click", retieveLoginDetails);
                }
            }
        }
        formNode.addEventListener("submit", retieveLoginDetails);


        //        loginButton = formNode.querySelector('button[type="submit"]') || formNode.querySelector('a[type="submit"]');
        //
        //        if(loginButton)
        //        {
        //            loginButton.addEventListener("click",retieveLoginDetails);
        //        }
    }
}

function listenToPasswordFieldKeyUp(passWordField) {
    passWordField.addEventListener("keyup", function(e) {
        if (e.which === 13) {
            retieveLoginDetails();

        }
    });
}

function retieveLoginDetails() {

    var userName = "";
    var passWord = "";
    var passWordInputField = getPassWordField();
    var userNameInputField;
    var formNode;


    if (passWordInputField) {
        formNode = getFormNode(passWordInputField);
        if (!formNode) {
            return;
        }
    } else {
        return;
    }

    userNameInputField = getUserNameField(formNode);

    if (userNameInputField) {
        userName = userNameInputField.value;
    }

    if (passWordInputField) {
        passWord = passWordInputField.value || passWordInputField.textContent;
    }
    if (passWord.length > 0) {
        storeLoginDetails(userName, passWord);
    } else {

        if (passWordInputField.hasAttribute("id") && passWordInputField.getAttribute("id") == "login-passwd") {
            setTimeout(function() {
                passWordInputField = getPassWordField();
                if (passWordInputField) {
                    listenToPasswordFieldKeyUp(passWordInputField);
                    formNode = getFormNode(passWordInputField);
                    formNode.addEventListener("submit", retieveLoginDetails);
                }
            }, 3000);

        }
    }

}

function findFormParentNode(childObj) {
    var testObj = childObj.parentNode;
    var count = 1;
    var parentName = "FORM";
    while (testObj.nodeName.toUpperCase() != parentName) {
        testObj = testObj.parentNode;
        if (!testObj) {
            return;
        }
        count++;
    }
    // now you have the object you are looking for - do something with it
    return testObj;
}
