var focusblur = "blured";
var TEXT_BOX = 'div.im-textfield_rich.im-chat__input-field';
var SEND_BTN = 'button.imButton.im-chat__input-action span.im-chat__input-action__send';
var unReadcount = 0;
var nodeToBeClicked = "";
var isLinkAttached = false;

this.Notification = function(title, options) {
    setTimeout(function() {
        var count = document.querySelector('div.nwa-msg-counter').textContent;
        webkit.messageHandlers.notification.postMessage(["icq", title, options.body, count, options.tag, options.icon]);
        if (focusblur.indexOf("blured") != -1) {
            window.location.reload(false);
        }
    }, 200);
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {
    callback('granted');
};

function logout() {
    document.querySelector('div.nwa-button.app-tab-button.settings-tab').click();
    setTimeout(function() {
        document.querySelector("div[data-key=goOffline]").click();
        document.querySelector("div.icq-offpage-bottom div").click();
    }, 200);
}

function addCustomEmoji() {
    if ($('input[type="file"]').length) {
        prompt("attachGif");
        $('input[type="file"]').click();
        
    } else {
        
    }
}

window.onload = function() {
    setTimeout(addReadAllNotification, 3000);
    setTimeout(addReadAllNotification, 5000);
    setTimeout(addReadAllNotification, 10000);
    setTimeout(addScheduler, 5000);
    
    setInterval(function() {
        
        var thisCountElement = document.querySelector("div.recent-tab div.icq-msg-counter");
        if (thisCountElement) {
            var displayStyle = thisCountElement.style.display;
            if (displayStyle.indexOf("none") == -1) {
                var count = thisCountElement.textContent;
                alert(count);
                if (unReadcount != parseInt(count)) {
                    alert("send notif");
                    webkit.messageHandlers.notification.postMessage(["icq", "count", "ICQCount", parseInt(count)]);
                    unReadcount = parseInt(count);
                }
            } else {
                prompt("Else Counter" + unReadcount);
                if (unReadcount != 0) {
                    webkit.messageHandlers.notification.postMessage(["icq", "count", "ICQCount", 0]);
                    unReadcount = 0;
                    prompt("NON_ZERO");
                }
            }
        }
    }, 2000);
};

$(document).on('keyup', TEXT_BOX, function() {
    spellCheckerOff(this);
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
});
$(window).blur(function() {
    focusblur = "blured";
});
$(window).focus(function() {
    focusblur = "focused";
});

$(document).mouseenter(function() {
    addReadAllNotification();
    addScheduler();
});

function spellCheckerOff(box) {
    if (box.textContent.length >= 1 && box.textContent.length < 5) {
    }
}

function addScheduler() {
    if ($('span.im-dialog__title-span').length) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {
    scheduleMessageForUser();
}

function scheduleMessageForUser() {
    setTimeout(function() {
        var nameOfUser = document.querySelector('span.im-dialog__title-span');
        if (nameOfUser.textContent) {
            var userid = "";
            var imgURL = "";
            
            if ($('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6')) {
                imgURL = $('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6').attr("src");
            }
            webkit.messageHandlers.notification.postMessage(["schedulemessage", nameOfUser.textContent, "", imgURL]);
        } else {
            openChatAlert();
        }
    }, 10);
}

function newConversation() {
    var composeButton = document.querySelector('div.im-ui-button.imButton.im-write-button');
    if (composeButton) {
        composeButton.click();
    }
}

function toDataUrl(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.responseType = 'blob';
    xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
            callback(reader.result);
        };
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.send();
}

function replyForNotification(userid, replymsg) {
    searchUserAndReply(userid, replymsg);
}


function searchUserAndReply(useridTG, replymsgTG) {
    var username = document.querySelector('div[data-nick="'+useridTG+'"]');
    var username1 = document.querySelector('div[data-friendly="'+useridTG+'"]');
    if (username) {
        username.click();
        
        setTimeout(function() {
            alert("insertMessage(replymsgTG);");
            insertMessage(replymsgTG);
            setTimeout(function() {
                alert("triggerClick");
                triggerClick();
            }, 200);
            
        }, 500);
    } else if (username1) {
        username1.click();
        
        setTimeout(function() {
            alert("insertMessage(replymsgTG);");
            insertMessage(replymsgTG);
            setTimeout(function() {
                alert("triggerClick");
                triggerClick();
            }, 200);
            
        }, 500);
    }  else {
        insertSearch(useridTG);
        setTimeout(function() {
            setTimeout(function() {
                alert("insertSearch");
                var username = document.querySelector('div[data-friendly="'+useridTG+'"]');
                if(username){
                    alert("search[0].click()");
                    var sevent = new MouseEvent('mousedown', {
                        'view': window,
                        'bubbles': true,
                        'cancelable': true
                    });
                    username.dispatchEvent(sevent);
                    setTimeout(function() {
                        alert("insertMessage(replymsgTG);");
                        insertMessage(replymsgTG);
                        setTimeout(function() {
                            alert("triggerClick");
                            triggerClick();
                        }, 200);
                        
                    }, 500);
                }
            }, 500);
        }, 2000);
    }
}

function insertMessage(message) {
    alert("insert message");
    var textField = document.querySelector(TEXT_BOX);
    if (!textField) {
        alert("textField is null");
    }
    dispatch(textField, "textInput", message);
}

function triggerClick() {
    
    var button = document.querySelector(SEND_BTN);
    if (button) {
        button.click();
    }
    
}

function insertSearch(searchText) {
    var searchbox = document.querySelectorAll('input[placeholder="Search"]');
    if(searchbox.length > 0){
        alert("insert message");
        searchbox[1].click();
        searchbox[1].focus();
        
        setTimeout(function() {
            alert("dispatchEvent");
            var textEvent = document.createEvent('TextEvent');
            textEvent.initTextEvent('textInput', true, true, null, searchText, 9, "en-US");
            
            searchbox[1].dispatchEvent(textEvent);
            searchbox[1].textContent = "";
            searchbox[1].textContent = searchText;
            setTimeout(function() {
                var event = new MouseEvent('mousedown', {
                    'view': window,
                    'bubbles': true,
                    'cancelable': true
                });
                searchbox[1].dispatchEvent(event);
                if(searchbox.length > 0){
                    __triggerKeyboardEvent(searchbox[1], 13, true);
                }
            }, 200);
            
        }, 1000);
        
    }
}

function __triggerKeyboardEvent(el, keyCode, meta) {
    var eventObj = document.createEventObject ?
    document.createEventObject() : document.createEvent("Events");
    
    if (eventObj.initEvent) {
        eventObj.initEvent("keydown", true, true);
    }
    
    eventObj.keyCode = eventObj.which = keyCode;
    if (meta) {
        eventObj.metaKey = true;
    }
    
    var i = el.dispatchEvent ? el.dispatchEvent(eventObj) : el.fireEvent("onkeydown", eventObj);
}

function dispatch(target, eventType, char) {
    var evt = document.createEvent("TextEvent");
    evt.initTextEvent(eventType, true, true, window, char, 0, "en-US");
    target.focus();
    target.dispatchEvent(evt);
    
    setTimeout(function() {
        setTimeout(function() {
        }, 200);
    }, 1000);
}

function addReadAllNotification() {
    if (document.querySelector('div.nwa-button.app-tab-button.settings-tab')) {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "off"]);
        return false;
    }
}

function readAllMessages() {
    var chatList = $('div.icq-recent-item.nwa-button');
    
    (function myLoop(i) {
        if (chatList[i - 1].querySelector('.icq-msg-counter').textContent) {
            setTimeout(function() {
                nodeToBeClicked = chatList[i - 1];
                prompt("openwhatsappchat"); //  your code here
                if (--i) myLoop(i); //  decrement i and call myLoop again if i > 0
            }, 200);
        } else {
            if (--i) myLoop(i);
        }
    })(chatList.length);
}

function openGivenChat() {
    nodeToBeClicked.click();
}

//-------------------------------------------------------
//@Sent From One Chat Link Attachment Handler
//-------------------------------------------------------

$(document).mouseenter(function(){
    addScheduler();
    addReadAllNotification();
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
});

jQuery(document.body).on('click', SEND_BTN, function(e) {
    //    alert("click_SEND_BTN");
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
    webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
});
function attachAppLink() {
    var nameOfUser = document.querySelector('span.im-dialog__title-span').textContent;
    webkit.messageHandlers.notification.postMessage(["userChecker", "ICQ", nameOfUser]);
}

function callBackForLinKAttach(messageText) {
    if (!isLinkAttached) {
        dispatch(document.querySelector(TEXT_BOX), 'textInput', messageText);
        isLinkAttached = true;
        triggerClick();
    }
}

function callBackForLinkAttachment(url) {
    var msg = " \nSent using \"One Chat\" - " + url;
    dispatch(document.querySelector(TEXT_BOX), 'textInput', msg);
    triggerClick();
}

