var totalUnreadCount = 0;
var shouldAddNotifObserver = true;

var nodeToBeClicked = "";
var TEXTBOXSL = 'div[aria-label="Write a message…"]';
//.msg-form__contenteditable.t-14.t-black--light.t-normal.flex-grow-1.notranslate';
var SEND_BUTTON = "footer button.msg-form__send-button.artdeco-button.artdeco-button--1";
jQuery(document).on('click', '#main > div > section.scaffold-layout__list.msg__list > div.relative.display-flex.justify-center.flex-column.overflow-hidden > ul li', function() {
    addScheduler();
    $(TEXTBOXSL).attr("spellcheck", "true");

});


//-------------------------------------------------------
//@HTML5 Notification Handlers
//-------------------------------------------------------
this.Notification = function (title, options)
{
    //    alert("NOTIF RECEIVED");
    if(totalUnreadCount == 0) totalUnreadCount = 1;
    webkit.messageHandlers.notification.postMessage(["LinkedIn",title,options.body,totalUnreadCount]);
    //setTimeout(function(){dockCountSL();},500);
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};


$(document).ready(function() {

    //                  var spotlight_OnenavItem = document.querySelector("#spotlight-one-nav-item");
    //                  if(spotlight_OnenavItem){
    //                  spotlight_OnenavItem.style.display = 'none';
    //                  }
    //
    //                  var appLauncherNavItem = document.querySelector("#app-launcher-nav-item");
    //                  if(appLauncherNavItem){
    //                  appLauncherNavItem.style.display = 'none';
    //                  }
    //
    //                  var feedNavItem = document.querySelector("#feed-nav-item");
    //                  if(feedNavItem){
    //                  feedNavItem.style.display = 'none';
    //                  }
    //                  var jobsNavItem = document.querySelector("#jobs-nav-item");
    //                  if(jobsNavItem){
    //                  jobsNavItem.style.display = 'none';
    //                  }
    //                  var myNetworkNavItem = document.querySelector("#mynetwork-nav-item");
    //                  if(myNetworkNavItem){
    //                  myNetworkNavItem.style.display = 'none';
    //                  }
    //                  var notificationsNavItem = document.querySelector("#notifications-nav-item");
    //                  if(notificationsNavItem){
    //                  notificationsNavItem.style.display = 'none';
    //                  }
    //
    //                  removeUnwantedElements();


});



//--------------------------------------------------
//Onload function
//--------------------------------------------------

window.onload = function() {

    addReadAllNotification();
    addScheduler();
    var spotlight_OnenavItem = document.querySelector("#spotlight-one-nav-item");
    if (spotlight_OnenavItem) {
        spotlight_OnenavItem.style.display = 'none';
    }

    var appLauncherNavItem = document.querySelector("#app-launcher-nav-item");
    if (appLauncherNavItem) {
        appLauncherNavItem.style.display = 'none';
    }

    var feedNavItem = document.querySelector("#feed-nav-item");
    if (feedNavItem) {
        feedNavItem.style.display = 'none';
    }
    var jobsNavItem = document.querySelector("#jobs-nav-item");
    if (jobsNavItem) {
        jobsNavItem.style.display = 'none';
    }
    var myNetworkNavItem = document.querySelector("#mynetwork-nav-item");
    if (myNetworkNavItem) {
        myNetworkNavItem.style.display = 'none';
    }
    var notificationsNavItem = document.querySelector("#notifications-nav-item");
    if (notificationsNavItem) {
        notificationsNavItem.style.display = 'none';
    }

    removeUnwantedElements();
    badgeCount();


    setInterval(removeUnwantedElements, 2000);
    addScheduler();

};






//--------------------------------------------------
//removing banner and footer elements
//--------------------------------------------------

function removeUnwantedElements() {
    var navMain = document.querySelector(".nav-main__inbug-container");
    if (navMain) {
        navMain.style.display = 'none';
    }
    var navSearchBar = document.querySelector(".nav-search-bar");
    if (navSearchBar) {
        navSearchBar.style.display = 'none';
    }

    setTimeout(function() {

        var bannerElements = document.querySelectorAll(".ad-banner");
        if (bannerElements) {
            var lengthOfArray1 = bannerElements.length;
            for (var i = 0; i < lengthOfArray1; i++) {
                bannerElements[i].style.display = 'none';
            }
        }
    }, 5000);


    setTimeout(function() {
        var footerElements = document.querySelector(".nav-footer-links.nav-footer-links--compact");
        if (footerElements) {
            footerElements.style.display = 'none';
        }

    }, 7000);



}

//--------------------------------------------------
//Observers
//--------------------------------------------------



function addObservers() {
    //        alert("add notification observers");
    addNotificationsObserver();

}

function addScheduler() {
    var profileButton = document.querySelector("h2#thread-detail-jump-target");
    if (profileButton) {

        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;

    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}


function schedule() {
    var userElement = document.querySelector("h2#thread-detail-jump-target");
    if (userElement) {
        var username = userElement.textContent;
        if (username) {
            username = username.trim(); //replace(/\s/g,' ').

            var checkNode = document.querySelector("div.msg-s-profile-card.msg-s-profile-card-one-to-one.ph3  div a img");
            if (checkNode) {
                var imgURL;
                alert("checkNode");
                if (checkNode.length && checkNode.attr('src').length) {
                    alert("checkNode.length");
                    imgURL = checkNode.attr('src');

                    toDataUrl(imgURL, function(base64Img) {

                        webkit.messageHandlers.notification.postMessage(["schedulemessage", username, "", base64Img]);

                    });

                } else {
                    webkit.messageHandlers.notification.postMessage(["schedulemessage", username, "", ""]);
                }

            } else {
                webkit.messageHandlers.notification.postMessage(["schedulemessage", username, "", ""]);
            }

        }
    } else {
        openChatAlert();
    }
}

function toDataUrl(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.responseType = 'blob';
    xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
            callback(reader.result);
        };
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.send();
}

//=========================================
//@Reply from Notification
//=========================================
function replyForNotification(useridSL, replymsgSL) {
//    alert(useridSL + " " + replymsgSL);
    var i;
    var chatList = document.querySelectorAll("#main > div > section.scaffold-layout__list.msg__list > div.relative.display-flex.justify-center.flex-column.overflow-hidden > ul > li");
    for (i = 0; i < chatList.length - 1; i++) {
        var userNameTag = chatList[i].querySelector("div.msg-conversation-card__content--selectable > div > div.msg-conversation-card__row.msg-conversation-card__title-row > h3");
        if (userNameTag) {
            var tempun = userNameTag.textContent;
            tempun = tempun.trim();
            if (useridSL.indexOf(tempun) != -1) {
                userNameTag.click();
                setTimeout(function() {
                    var textEvent = document.createEvent('TextEvent');
                    textEvent.initTextEvent('textInput', true, true, window, replymsgSL, 0, "en-US");
                    var textbox_node = document.querySelector(TEXTBOXSL);
                   
                    if(textbox_node){
                        textbox_node.focus();
                        textbox_node.dispatchEvent(textEvent);
                        ignoreNotification = true;
                        setTimeout(function() {
                            alert("send");
                            $(SEND_BUTTON).click();
                        }, 300);
                    }
                 
                }, 1000);
                break;
            }
        }
    }
}

function openGivenChat() {
    setTimeout(function() {
        //               $('#client_body').click();
        if (nodeToBeClicked) {
            nodeToBeClicked.click();
        }
        //               $('#messages_unread_status a.clear_unread_messages').click();
    }, 500);
}

function addNotificationsObserver() {
    var target = document.querySelector("#main > div > section.scaffold-layout__list.msg__list");
    if (target) {
        if (shouldAddNotifObserver) {


            var observer = new MutationObserver(function(mutations) {

                badgeCount();


            });

            var config = {
                attributes: false,
                childList: true,
                characterData: false,
                subtree: false
            };
            observer.observe(target, config);
            shouldAddNotifObserver = false;
        }
    } else {
        setTimeout(function() {
            addNotificationsObserver();
        }, 2000);
    }
}

//--------------------------------------------------
//start New conversation
//--------------------------------------------------
function newConversation() {
    var newConvButton = document.querySelector('a[href="/messaging/thread/new/"]');
    if (newConvButton) {
        newConvButton.click();
    }
}

//--------------------------------------------------
//Linkedin logout
//--------------------------------------------------

function logout() {



    //    var event = new MouseEvent('mousedown', { 'view': window, 'bubbles': true, 'cancelable': true });
    //    settingDropdownButton.dispatchEvent(mousedown);
    //    return;


    var settingDropdownButton = document.querySelector("div.global-nav__me.artdeco-dropdown.artdeco-dropdown--placement-bottom.artdeco-dropdown--justification-left.ember-view");

    var headerButtons = document.querySelectorAll("header#global-nav div.global-nav__content nav.global-nav__nav ul.global-nav__primary-items li.global-nav__primary-item");
    var i = 0;
    if (settingDropdownButton) {


        alert("settingDropdownButton");
        for (i = 0; i < headerButtons.length; i++) {
            var event = new MouseEvent('mousedown', {
                'view': window,
                'bubbles': true,
                'cancelable': true
            });
            var dropbutton = headerButtons[i].querySelector('button[data-control-name="nav.settings"]');
            headerButtons[i].click();
            if (dropbutton) {
                alert("dropbutton");
                //            setTimeout(function(){
                //var divButton = headerButtons[i].querySelector("div");
                dropbutton.style.zIndex = 1000;
                dropbutton.click();
                dropbutton.dispatchEvent(event);

                //            divButton.click();
                var subMenu = dropbutton.querySelectorAll("ul.global-nav__secondary-items li");
                var j = 0;
                for (j = 0; j < subMenu.length; j++) {
                    var signoutBtn = subMenu[j].textContent;
                    if (signoutBtn.indexOf("Sign") != -1) {
                        signoutBtn.click();
                    }
                }
                //            }, 500);
            }
        }
    }

    var logoutPortal = document.querySelector('a[href="/m/logout/"]');
    if (logoutPortal) {
        alert("logoutPortal");
        logoutPortal.click();
        return;
    }

}


function msgButtonClickTest() {
    //    var msgOverlay = document.querySelector("header.msg-overlay-bubble-header");
    //    msgOverlay.click();
    var ele = document.getElementById("ember38");

}

function badgeCount() {
    var count = 0;
    var countList = document.querySelectorAll("span.notification-badge__count");
    if (countList) {
        for (i = 0; i < countList.length; i++) {
            count = count + parseInt(countList[i].innerText);
        }
    }

    totalUnreadCount = count;
    messageNotifications();
}

function messageNotifications() {
    if (totalUnreadCount) {
        if (totalUnreadCount === 1) {
            webkit.messageHandlers.notification.postMessage(["LinkedIn", "New Message Received", "", totalUnreadCount]);
        } else {
            webkit.messageHandlers.notification.postMessage(["LinkedIn", "You have " + totalUnreadCount + " unread messages", "", totalUnreadCount]);
        }
    } else {
        webkit.messageHandlers.notification.postMessage(["LinkedIn", "count", "", "0"]);
    }

}


function addReadAllNotification() {
    var msgConversation = document.querySelectorAll("msg-conversations-container");
    //var badgedMessageNav = document.querySelector("header nav ul li#messaging-nav-item span.nav-item__badge");
    var chatList = document.querySelectorAll("div#messaging div.msg-conversations-container ul li");
    if (msgConversation) {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "off"]);
        return false;
    }

}


function readAllMessages() {
    var chatList = document.querySelectorAll("#main > div > section.scaffold-layout__list.msg__list > div.relative.display-flex.justify-center.flex-column.overflow-hidden > ul > li");

    var i = 0;
    for (i = 0; i < chatList.length - 1; i++) {
        var nodeToBeClicked = chatList[i].querySelector("div.msg-conversation-card__content--selectable > div > div.msg-conversation-card__row.msg-conversation-card__title-row > h3");
        if (nodeToBeClicked) {
            nodeToBeClicked.click();
        }
    }

    //    var chatList = document.querySelectorAll(".msg-conversation-listitem__message-snippet");
    //    (function readChat(i) {
    //     setTimeout(function(){
    //                var node = chatList[i-1];
    //                openGivenChat(node);
    //                i--;
    //                if(i>0) readChat(i);
    //                }, 500)
    //     })(chatList.length);
    removeUnwantedElements();
}

function openGivenChat(node) {
    node.click();
}

jQuery(document.body).on('click', SEND_BUTTON, function(e) {
    //    alert("click_SEND_BTN");
    if (!isLinkAttached) {
        setTimeout(attachAppLink, 200);
    }
    webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
});


jQuery(document.body).on('keyup', TEXTBOXSL, function(e) {
    
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
    } else {
        isLinkAttached = false;
    }
});

function attachAppLink() {
    var nameOfUser = document.querySelector('h2#thread-detail-jump-target');
    if (nameOfUser) {
        webkit.messageHandlers.notification.postMessage(["userChecker", "Twitter", nameOfUser.textContent]);
    }
}

function callBackForLinKAttach(msgText) {
    if (!isLinkAttached) {
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
        isLinkAttached = true;
        document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
        
        setTimeout(function(e) {
            __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
            triggerClick();
        }, 2000);
    }
}

function callBackForLinkAttachment(url) {
    console.log(url);
    var msg = "Sent using \"One Chat\" - " + url;
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msg, 9, "en-US");
    document.querySelector(TEXTBOXSL).dispatchEvent(textEvent);
    setTimeout(function(e) {
        __triggerKeyboardEvent(document.querySelector(TEXTBOXSL), 13, true);
        triggerClick();
    }, 2000);
}


function triggerClick() {
    setTimeout(function() {
//        if (document.querySelector(TEXTBOXTG).length > 0) {
            alert("triggerClick document.querySelector(TEXTBOXTG).length > 0");
            autoClick = true;
            document.querySelector(TEXTBOXSL).focus();
            __triggerKeyboardEvent(document.querySelector(TEXTBOXSL),13,true);
            if(document.querySelector(SEND_BUTTON)){
                document.querySelector(SEND_BUTTON).click();
            }
            
            var els = document.querySelectorAll('div[aria-label="Send"]');
            if(els.length > 0){
                els[0].click();
            }
    }, 500);
}
