// injected into the webview as a user script

// Facebook selectors
var SETTINGS_BUTTON = '._30yy._2fug._p',
NEW_MESSAGE_BUTTON = '._36ic._5l-3 > a._30yy',
INFORMATION_BUTTON = '._fl3._30yy';

var UPLOAD_BUTTON = '._m._4q60._3rzn._6a',
UPLOAD_FORM = '._4rv4 form';

var TEXT_BOX = 'div[aria-label="Message"]',
SEARCH_BOX = 'input[aria-label="Search Messenger"]';

var TITLE_BAR = '._5743',
LAST_ACTIVE = '._2v6o';
var isLinkAttached = false;

var CURRENT_CONVERSATION_NAME = TITLE_BAR + ' span',
CONVERSATION_LIST = 'div[aria-label="Chats"]',
SELECTED_CONVERSATION = 'a.oajrlxb2.gs1a9yip.mtkw9kbi.tlpljxtp.qensuy8j.ppp5ayq2.goun2846.ccm00jje.s44p3ltw.mk2mc5f4.rt8b4zig.n8ej3o3l.agehan2d.sk4xxmp2.rq0escxv.nhd2j8a9.mg4g778l.pfnyh3mw.p7hjln8o.tgvbjcpo.hpfvmrgz.l9j0dhe7.i1ao9s8h.esuyzwwr.f1sip0of.du4w35lb.btwxx1t3.abiwlrkh.p8dawk7l.lzcic4wl.ue3kfks5.pw54ja7n.uo3d90p7.l82x9zwi.a8c37x1j.kvgmc6g5.cxmmr5t8.oygrvhab.hcukyx3x.jktsbyx5.rv4hoivh.osnr6wyh.h4z51re5.i224opu6';

var MENUCL = 'div[aria-label="Settings, help and more"]'; //
var _MENU_ITEMS = 'div[role="menuitem"]';
var SETTINGS_MENU_ITEM = _MENU_ITEMS + ':first-child';
var LOGOUT_MENU_ITEM = _MENU_ITEMS + ':last-child';
var UNREAD_CONVERSATION = 'div[aria-label="Mark as read"]',
UNREAD_MESSAGE_NAME = UNREAD_CONVERSATION + ' ._1ht6',
UNREAD_MESSAGE_TEXT = UNREAD_CONVERSATION + ' ._1htf',
UNREAD_MESSAGE_ROW = UNREAD_CONVERSATION + '._1ht1 div',
UNREAD_MESSAGE_PICTURE = '._1ht3 ._55lt > .img';

var EMOTICONS = '.emoticon_text',
ALL_EMOJI = '.emoticon, ._1az',
MUTED = '._569x ._56ck';

var nodeToBeClicked = "";
var PASSWORD_FIELD = '#pass';

var notificationCheckBox = '._55sg._4ng2._kv1 input[type="checkbox"]';

var _localeKeyword = Array.prototype.filter.call(document.body.classList, function(e) {
    return e.startsWith("Locale");
})[0];

// Resistant if Facebook stops exposing locale as a class
var LOCALE = _localeKeyword ? _localeKeyword.replace("Locale_", "") : "";

var YOU_KEYWORDS = {
    "default": "You: ",
    "tr_TR": "Sen: "
};
var YOU = YOU_KEYWORDS.hasOwnProperty(LOCALE) ? YOU_KEYWORDS[LOCALE] : YOU_KEYWORDS["default"];

function CONVERSATION_LINK(user_id) {
    return '[data-reactid="' + user_id + '"] a';
}

function ID(id) {
    return '[href="' + id + '"]';
}

var showMediaUploadAlert = true;
window.onload = myeventfunctionFB;


this.Notification = function(title, options) {
    //alert("Messenger Notif");
    
    
    var id = document.querySelector(UNREAD_MESSAGE_ROW).getAttribute('id');
    
    webkit.messageHandlers.notification.postMessage(["Messenger", title, options.body, id, options.icon]);
    dockCountFM();
};
this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {
    callback('granted');
};

(function() {
    if (!window.navigator) window.navigator = {};
    //if getuserMedia is called -> If the user requests native camera
    window.navigator.getUserMedia = function() {
        webkit.messageHandlers.callbackHandler.postMessage(arguments);
    }
    
})();


jQuery(document).on('click', 'a div._3jk input[type="file"]', function() {
    if (showMediaUploadAlert) {
        confirm('To upload media, drag and drop the file into the One Chat window.');
    }
});


jQuery(document.body).on('keyup', TEXT_BOX, function(e) {
    alert("keyup_TEXT_BOX");
    var rect = document.querySelector(TEXT_BOX).getBoundingClientRect();
    if (e.which === 32) {
        var numberOFWords = (document.querySelector(TEXT_BOX).textContent.match(new RegExp(" ", "g")) || []).length;
        
        if (numberOFWords >= 0) {
            if (verGreaterThanEleven) {
                webkit.messageHandlers.notification.postMessage(["enableStickersButton", "on", rect.bottom, rect.right]);
            }
            
        }
    }
    if (e.which === 13) {
        if (!isLinkAttached) {
            attachAppLink();
        }
        
        webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
    } else {
        isLinkAttached = false;
    }
    if (document.querySelector(TEXT_BOX).textContent.length == 3) {
        if (verGreaterThanEleven) {
            webkit.messageHandlers.notification.postMessage(["enableStickersButton", "on", rect.bottom, rect.right]);
        }
    }
    
    if (e.which === 8 || e.which === 46) {
        if (document.querySelector(TEXT_BOX).textContent.length < 3) {
            webkit.messageHandlers.notification.postMessage(["enableStickersButton", "off"]);
        }
    }
    
});

jQuery(document.body).on('click', 'ul._4rv4 a._30yy._38lh', function(e) {
    setTimeout(attachAppLink, 200);
});

jQuery(document.body).on('click', CONVERSATION_LIST, function(e) {
    setTimeout(addScheduler, 300);
    $(TEXT_BOX).attr("spellcheck", true);
    
});

jQuery(document).mouseenter(function() {
    if (!isLinkAttached) {
        attachAppLink();
    }
    addReadAllNotification();
});

function myeventfunctionFB() {
    
    addScheduler();
    addReadAllNotification();
    addChatListChangeObserver();
    removemessengerlogo();
    if (navigator.appVersion.indexOf("10_11") > -1) {
        showMediaUploadAlert = true;
    } else {
        showMediaUploadAlert = false;
    }
    
    prompt("Onload Call");
    
    
    
    
    document.body.onkeypress = function(e) {
        // If no inputs are focused, or we're at the start of the message input (to prevent system beep), focus the message input and trigger the keypress.
        if ((!document.querySelector(':focus') || (document.querySelector(TEXT_BOX + ':focus') && window.getSelection().baseOffset === 0)) && !e.metaKey && !e.ctrlKey) {
            var char = event.which || event.keyCode;
            
            // Focus the input at the end of any current text.
            var el = document.querySelector(TEXT_BOX),
            range = document.createRange(),
            sel = window.getSelection();
            range.setStart(el, 1);
            range.collapse(true);
            sel.removeAllRanges();
            sel.addRange(range);
            
            // Trigger the captured key press.
            var textEvent = document.createEvent('TextEvent');
            textEvent.initTextEvent('textInput', true, true, null, String.fromCharCode(char), 9, "en-US");
            el.dispatchEvent(textEvent);
            
            return false;
        }
    };
    
}

var shouldObserveChatList = true;

function addChatListChangeObserver() {
    
    var target = document.querySelector('div[aria-label="Chats"]');
    //alert("Messenger MessageView "+target);
    if (target) {
        if (shouldObserveChatList) {
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) {
                    alert("ChatList Mutation " + mutation.type);
                    if (mutation.type === 'characterData') {
                        dockCountFM();
                    }
                });
            });
            
            var config = {
            attributes: true,
            childList: true,
            characterData: true,
            subtree: true
            };
            observer.observe(target, config);
            alert("ChatList Observer Added");
            shouldObserveChatList = false;
            
            //dockCountFM();
        }
    } else {
        setTimeout(function() {
            addChatListChangeObserver();
        }, 2000);
    }
}

var shouldObserveMessageView = true;

function addMessageViewChangeObserver() {
    var target = document.querySelector('div.iqfcb0g7.tojvnm2t.a6sixzi8.k5wvi7nf.q3lfd5jv.pk4s997a.bipmatt0.cebpdrjk.qowsmv63.owwhemhu.dp1hu0rb.dhp61c6y.l9j0dhe7.iyyx5f41.a8s20v7p');
    //alert("Messenger MessageView "+target);
    if (target) {
        if (shouldObserveMessageView) {
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) {
                    alert("Messenger MessageView Mutation " + mutation.type);
                    //
                    removeCallingButtons();
                    dockCountFM();
                });
            });
            
            var config = {
            attributes: true,
            childList: true,
            characterData: true,
            subtree: true
            };
            observer.observe(target, config);
            alert("Messenger MessageView Observer Added");
            shouldObserveMessageView = false;
            
            //dockCountFM();
        }
    } else {
        setTimeout(function() {
            addMessageViewChangeObserver();
        }, 2000);
    }
}



function removeCallingButtons() {
    var cameraButton = document.querySelector("a._4rv5[role=button]");
    if (cameraButton) {
        cameraButton.style.display = "none";
    }
    var playButton = document.querySelector("a._4ce_[role=button]");
    if (playButton) {
        playButton.style.display = "none";
    }
}

function dockCountFM() {
    var id = document.querySelectorAll('div[aria-label="Mark as read"]');
    if (id.length > 0) {
        var i = 0;
        for (i = 0; i <= 10; i++) {
            var newMessage = id[i].textContent;
            if (newMessage.length > 0 && newMessage == "1 m") {
                alert(newMessage.localeCompare("1 m"));
                webkit.messageHandlers.notification.postMessage(["Messenger", "count", "FMCount", newMessage, null]);
            } else {
                webkit.messageHandlers.notification.postMessage(["Messenger", "count", "FMCount", newMessage, null]);
            }
        }
    }
}

//=========================================
//@Auto Login Handlers
//=========================================
function clickLoginButton(formNode) {
    if (formNode) {
        formNode.submit();
    }
}

function autoLoginWithUserDetails(username, password) {
    $('input[type="text"]').val(username);
    $(PASSWORD_FIELD).val(password);
    $('#loginbutton').click();
}

function setAwesompleteXPosition() {
    var width = $(window).width() / 2.655;
    $('.awesomplete > ul').css('left', width);
}

function privateMethod(isPrivate) {
    if (isPrivate.indexOf('true') != -1) {
        setTimeout(function() {
            var keepmesign = document.querySelector('div._43dj');
            if (keepmesign) {
                keepmesign.parentNode.removeChild(keepmesign);
            }
        }, 200);
    } else {
        var checkBoxKeepMe = document.querySelector('div label.uiInputLabelInput input[type = "checkbox"]');
        if (checkBoxKeepMe)
            checkBoxKeepMe.checked = true;
    }
}


//FB Handlers

function newConversation() {
    document.querySelector(NEW_MESSAGE_BUTTON).click();
}

function searchContacts() {
    document.querySelector('input._58al').click();
    document.querySelector('input._58al').focus();
    
}

function logout() {
    var MENUCL = 'div[aria-label="Settings, help and more"]'; //
    var _MENU_ITEMS = 'div[role="menuitem"]';
    var settings = document.querySelector(MENUCL);
    if (settings) {
        settings.click();
        setTimeout(function() {
            var menuItems = document.querySelectorAll('div[role="menuitem"]');
            var i;
            for (i = 0; i < menuItems.length; i++) {
                var spanElement = menuItems[i].querySelector("span.d2edcug0.hpfvmrgz.qv66sw1b.c1et5uql.b0tq1wua.a8c37x1j.keod5gw0.nxhoafnm.aigsh9s9.d9wwppkn.fe6kdd0r.mau55g9w.c8b282yb.hrzyx87i.jq4qci2q.a3bd9o3v.ekzkrbhg.oo9gr5id.hzawbc8m");
                if (spanElement) {
                    var temp = spanElement.textContent;
                    if (temp.indexOf('Log') != -1) {
                        spanElement.click();
                    }
                }
            }
        }, 3000);
        
    }
}

function enableDesktopNotification() {
    if (document.querySelector(MENUCL)) {
        document.querySelector(MENUCL).click();
        document.querySelector(SETTINGS_MENU_ITEM).click();
        
        var descNotiCheckBox = document.querySelectorAll(notificationCheckBox);
        if (descNotiCheckBox) {
            descNotiCheckBox[1].checked = true;
        }
        setTimeout(function() {
            document.querySelector('._30vt button').click();
        }, 1000);
        
    }
}


function showNotification() {
    const notification = new Notification("Messenger", {
    body: "new message..!",
        
    });
}


function infoFB() {
    document.querySelector(INFORMATION_BUTTON).click();
    
}

function removemessengerlogo() {
    var elemfbl = document.querySelector('.img.sp_JS93z0cAMp7.sx_c7eebe');
    var elemfbh = document.querySelector('._5hy4');
    if (elemfbl) {
        elemfbl.parentNode.removeChild(elemfbl);
    }
    if (elemfbh) {
        elemfbh.parentNode.removeChild(elemfbh);
    }
}


function removemobilelabelFB() {
    var elem = $('._s15').css('display', "none");
    prompt("resizewindow");
    return false;
}


function addScheduler() {
    if ($('div.l9j0dhe7').length) {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["messageSchedulerStatus", "off"]);
        return false;
    }
}

function schedule() {
    scheduleMessageForUser();
}

function scheduleMessageForUser() {
    setTimeout(function() {
        var nameOfUser = document.querySelector('div[role="main"] span.a8c37x1j.d2edcug0.ni8dbmo4.ltmttdrg.g0qnabr5');
        if (nameOfUser.textContent) {
            var userid = "";
            var imgURL = "";
            if (document.querySelector(SELECTED_CONVERSATION)) {
                userid = document.querySelector(SELECTED_CONVERSATION).getAttribute('href');
            }
            
            if ($('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6')) {
                imgURL = $('img.a8c37x1j.d2edcug0.sn7ne77z.bixrwtb6').attr("src");
            }
            
            webkit.messageHandlers.notification.postMessage(["schedulemessage", formatLink(userid), nameOfUser.textContent, imgURL]);
        } else {
            openChatAlert();
        }
    }, 10);
    
}

function formatLink(link) {
    var formattedString = "";
    formattedString = link.replace("https://www.facebook.com", "/t");
    return formattedString;
}

// Handle pasted image data forwarded from the wrapper app.
function pasteImage(base64Data) {
    
    var blob = b64toBlob(base64Data, 'image/png'),
    uploader = getValueForFirstObjectKey(getValueForFirstObjectKey(__REACT_DEVTOOLS_GLOBAL_HOOK__._renderers).ComponentTree.getClosestInstanceFromNode(document.querySelector(UPLOAD_FORM).parentElement)._renderedChildren);
    
    
    
    uploader._instance.uploadFiles([blob]);
}

// Convert base64 encoded data to a Blob.
function b64toBlob(b64Data, contentType, sliceSize) {
    contentType = contentType || '';
    sliceSize = sliceSize || 512;
    
    var byteCharacters = atob(b64Data),
    byteArrays = [];
    
    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
        var slice = byteCharacters.slice(offset, offset + sliceSize);
        
        var byteNumbers = new Array(slice.length);
        for (var i = 0; i < slice.length; i++) {
            byteNumbers[i] = slice.charCodeAt(i);
        }
        
        var byteArray = new Uint8Array(byteNumbers);
        
        byteArrays.push(byteArray);
    }
    
    var blob = new Blob(byteArrays, {
    type: contentType
    });
    return blob;
}

function replyForNotification(userid, answer) {
    
    //    alert(userid);
    var userElement = document.querySelector('a[href="' + userid + '"]');
    if (userElement) {
        alert(userElement);
        var nameOfUser = document.querySelector('div[role="main"] span.a8c37x1j.d2edcug0.ni8dbmo4.ltmttdrg.g0qnabr5');
        if (nameOfUser) {
            var selecteduserid = document.querySelector(SELECTED_CONVERSATION).getAttribute('href');
            if (selecteduserid.trim().indexOf(userid) != -1) {} else {
                userElement.click();
            }
        } else {
            userElement.click();
        }
        
        setTimeout(function() {
            var textEvent = document.createEvent('TextEvent');
            textEvent.initTextEvent('textInput', true, true, null, answer, 9, "en-US");
            document.querySelector(TEXT_BOX).dispatchEvent(textEvent);
            setTimeout(function() {
                var sendDiv = document.querySelector('div[aria-label="Press Enter to send"]');
                if (sendDiv) {
                    sendDiv.click();
                }
            }, 200);
            
            attachAppLink();
        }, 50);
    }
    
}

function searchUserAndReply(useridTG, replymsgTG) {
    
    setTimeout(function() {
        insertSearch(useridTG);
        setTimeout(function() {
            alert("insertSearch");
            var searchRecent = document.querySelectorAll("div.search-group-recent.search-group.search-group-contacts ul.chatlist a.chatlist-chat.rp");
            if (searchRecent.length > 0) {
                alert("search[0].click()");
                var event = new MouseEvent('mousedown', {
                    'view': window,
                    'bubbles': true,
                    'cancelable': true
                });
                searchRecent[0].dispatchEvent(event);
                setTimeout(function() {
                    alert("insertMessage(replymsgTG);");
                    insertMessage(replymsgTG);
                    triggerClick();
                    if (!isLinkAttached) {
                        attachAppLink();
                    }
                    
                }, 400);
            } else {
                var search = document.querySelectorAll("div.search-group.search-group-contacts ul.chatlist a.chatlist-chat.rp");
                if (search.length > 0) {
                    alert("search[0].click()");
                    var event = new MouseEvent('mousedown', {
                        'view': window,
                        'bubbles': true,
                        'cancelable': true
                    });
                    search[0].dispatchEvent(event);
                    setTimeout(function() {
                        alert("insertMessage(replymsgTG);");
                        insertMessage(replymsgTG);
                        triggerClick();
                        if (!isLinkAttached) {
                            attachAppLink();
                        }
                        
                    }, 400);
                }
            }
        }, 200);
        
    }, 2000);
    
}

function insertSearch(searchText) {
    var searchbox = document.querySelector(SEARCH_BOX);
    if (searchbox) {
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, searchText, 9, "en-US");
        searchbox.dispatchEvent(textEvent);
        var msg = searchbox.textContent + " " + searchText;
        searchbox.textContent = msg;
        var event = new MouseEvent('mousedown', {
            'view': window,
            'bubbles': true,
            'cancelable': true
        });
        document.dispatchEvent(event);
    }
}


function addCustomEmoji() {
    if ($('input[title ="Add Files"]').length) {
        prompt("attachGif");
        $('input[title ="Add Files"]').click();
    } else {
        selectAChatAlert();
    }
}

function sentenceForGuggyStickerSearch() {
    var sentence = "";
    if (document.querySelector(TEXT_BOX)) {
        sentence = document.querySelector(TEXT_BOX).textContent;
    }
    return sentence;
}

function attachAppLink() {
    var nameOfUser = document.querySelector('div[role="main"] span.a8c37x1j.d2edcug0.ni8dbmo4.ltmttdrg.g0qnabr5');
    if (nameOfUser) {
        webkit.messageHandlers.notification.postMessage(["userChecker", "Messenger", nameOfUser.textContent]);
    }
    
}

function callBackForLinKAttach(msgText) {
    if (!isLinkAttached) {
        var textEvent = document.createEvent('TextEvent');
        textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
        isLinkAttached = true;
        document.querySelector(TEXT_BOX).dispatchEvent(textEvent);
        __triggerKeyboardEvent(document.querySelector(TEXT_BOX), 13, true);
    }
    
}

function callBackForLinkAttachment(url) {
    console.log(url);
    var msg = "Sent using \"One Chat\" - " + url;
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msg, 9, "en-US");
    document.querySelector(TEXT_BOX).dispatchEvent(textEvent);
    __triggerKeyboardEvent(document.querySelector(TEXT_BOX), 13, true);
}

function addReadAllNotification() {
    if ($(UNREAD_CONVERSATION).length) {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "on"]);
        return true;
    } else {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus", "off"]);
        return false;
    }
}

function readAllMessages() {
    var chatList = $(UNREAD_CONVERSATION);
    console.log(chatList);
    (function myLoop(i) {
        
        setTimeout(function() {
            nodeToBeClicked = chatList[i - 1];
            console.log(nodeToBeClicked);
            nodeToBeClicked.click();
            if (--i) myLoop(i);
        }, 2000);
    })(chatList.length);
}

function openGivenChat() {
    console.log("click: " + nodeToBeClicked);
    nodeToBeClicked.click();
}
