var dockCounterWC = 0;
var showMediaUploadAlert = true;
var autoClick = false;
var TEXT_BOX = '#editArea';

this.Notification.permission = 'granted';
this.Notification.requestPermission = function(callback) {callback('granted');};

this.Notification = function (title, options)
{
  
};

window.onload = startWC;

function logout()
{
    document.querySelectorAll('a.opt')[0].click();
    document.querySelectorAll('ul.dropdown_menu li a')[4].click();
}

function newConversation()
{
    document.querySelectorAll('a.opt')[0].click();
    document.querySelectorAll('ul.dropdown_menu li a')[0].click();
}

function addCustomEmoji()
{
    if($('input[type="file"]').length)
    {
        prompt ("attachGif");
        $('input[type="file"]').click();
    }
    else
    {
        selectAChatAlert();
    }
}

function blobreader(urldown)
{
    var xhr = new XMLHttpRequest;
    xhr.responseType = 'blob';
    
    xhr.onload = function()
    {
        var recoveredBlob = xhr.response;
        var reader = new FileReader;
        
        reader.onload = function()
        {
            var blobAsDataUrl = reader.result;
            downloadURI(blobAsDataUrl, "name");
        };
        
        reader.readAsDataURL(recoveredBlob);
    };
    
    xhr.open('GET', urldown);
    xhr.send();
}

function downloadURI(uri, name)
{
    var link = document.createElement("a");
    link.download = name;
    link.href = uri;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}

function notifyWC(totalWCn)
{
    var maintx = document.querySelectorAll('.ng-scope .ng-scope .chat_item.slide-left.ng-scope')[0];
    var WCusername = maintx.querySelectorAll('span.nickname_text.ng-binding')[0];
    var WCusertext = maintx.querySelectorAll('p.msg.ng-scope span.ng-binding')[0];
    var msgWC = WCusertext.textContent;
    var usernWC = WCusername.textContent;
    
    if(msgWC.length==0)
    {
        if(WCusertext.getElementsByTagName("img"))
        msgWC = ":Emoji"
    }
     webkit.messageHandlers.notification.postMessage(["Wechat",usernWC,msgWC,totalWCn]);
}

function startWC()
{
    this.Notification.permission = 'granted';
    this.Notification.requestPermission = function(callback) {callback('granted');};
    
    if(navigator.appVersion.indexOf("10_11") > -1) {
        showMediaUploadAlert = true;
    }
    else {
        showMediaUploadAlert = false;
    }

    setInterval(function()
                {
                dockCountWC();
                },200);
    
    setTimeout(addReadAllNotification,5000);
    setTimeout(addReadAllNotification,10000);
    
    removeNode('a[ng-if="isMacOS"]');
    
    setTimeout(function()
               {
               removeNode('a[ng-if="isMacOS"]');
               },3000);
    
    setTimeout(function()
               {
               removeNode('a[ng-if="isMacOS"]');
               },1500);
}

jQuery(document).on('click', 'input[type="file"]', function ()
                    {
                    if(showMediaUploadAlert)
                    {
                    confirm('To upload media, drag and drop the file into the One Chat window.');
                    }
                    });

jQuery(document).on('keyup', 'pre#editArea', function (e)
                    {
                    
                    if(this.textContent.length>=1 && this.textContent.length<5)
                    {
                        //this.setAttribute("spellcheck",false);
                    }
                    
                    if(e.which === 13)
                    {
                    if(!autoClick)
                    attachAppLink();
                    }
                    else
                    {
                    autoClick = false;
                    }
                    });

jQuery(document).on('click', 'a.btn.btn_send', function ()
                    {
                    if(!autoClick)
                    {
                    setTimeout(attachAppLink,200);
                    }
                    });

jQuery(document).on('permissionrequest', function(e)
                             {
                             
                             if (e.permission === 'fullscreen')
                             {
                             e.request.allow();
                             }
                             });

jQuery(document).ready(function()
                    {
                       setTimeout(function()
                                  {
                                    removeNode('a[ng-if="isMacOS"]');
                                  },1000);
                       
                       setTimeout(addReadAllNotification,3000);
                       setTimeout(addReadAllNotification,5000);
                    });

jQuery(document).mouseenter(function()
                            {
                                addReadAllNotification();
                            });

function dockCountWC()
{
    var xSK = document.querySelectorAll('i.icon.web_wechat_reddot_middle.ng-binding');
    var tempSK=0;
    var iSK;
    totalSK=0;
    
    for (iSK = 0; iSK < xSK.length; iSK++)
    {
        tempSK =  parseInt(xSK[iSK].innerHTML);
        totalSK=totalSK+tempSK;
    }
    if(dockCounterWC != totalSK)
    {
        if(totalSK > dockCounterWC)
        {
            setTimeout(function() {
                        notifyWC(totalSK);
                        },5);
        }
        else
            webkit.messageHandlers.notification.postMessage(["Wechat","count","WCCount",totalSK]);
        
        dockCounterWC=totalSK;
    }else
        return;
}

function replyForNotification(useridSK, replymsgSK)
{
    var maintx = document.querySelectorAll('.ng-scope .ng-scope .chat_item.slide-left.ng-scope');
    var i;
    
    for (i = 0; i < maintx.length; i++)
    {
        var mainty = document.querySelectorAll('.ng-scope .ng-scope .chat_item.slide-left.ng-scope')[i];
        var temp= mainty.querySelectorAll('span.nickname_text.ng-binding')[0].textContent;
        if (temp.indexOf(useridSK) != -1)
        {
            var event = new MouseEvent('click', { 'view': window, 'bubbles': true, 'cancelable': true });
            mainty.dispatchEvent(event);
           setTimeout(function()
                      {
                       var textEvent = document.createEvent('TextEvent');
                       textEvent.initTextEvent('textInput', true, true, null, replymsgSK, 9, "en-US");
                       document.querySelector('div.content.ng-isolate-scope pre.flex').focus();
                       document.querySelector('div.content.ng-isolate-scope pre.flex').dispatchEvent(textEvent);
                      autoClick = false;
                       document.querySelector('a.btn.btn_send').click();
                      
//                      attachAppLink();
                       }, 500);
                   return;
        }
    }
}

function attachAppLink()
{
    var nameOfUser = document.querySelector('#chatArea div.box_hd div.title_wrap div a').textContent
    webkit.messageHandlers.notification.postMessage(["userChecker","Wechat",nameOfUser]);
}

function callBackForLinKAttach(msgText)
{
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msgText, 9, "en-US");
//    textEvent.initTextEvent('textInput', true, true, null, "Sent using \"One Chat\" - http://bit.ly/OneChatApp", 9, "en-US");
    document.querySelector('div.content.ng-isolate-scope pre.flex').focus();
    document.querySelector('div.content.ng-isolate-scope pre.flex').dispatchEvent(textEvent);
    autoClick = true;
    document.querySelector('a.btn.btn_send').click();
}

function callBackForLinkAttachment(url) {
    var msg = "\nSent using \"One Chat\" - "+url;
    var textEvent = document.createEvent('TextEvent');
    textEvent.initTextEvent('textInput', true, true, null, msg, 9, "en-US");
    document.querySelector('div.content.ng-isolate-scope pre.flex').focus();
    document.querySelector('div.content.ng-isolate-scope pre.flex').dispatchEvent(textEvent);
    autoClick = true;
    document.querySelector('a.btn.btn_send').click();
}

function addReadAllNotification()
{
    if($('a.opt').length)
    {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","on"]);
        return true;
    }
    else
    {
        webkit.messageHandlers.notification.postMessage(["readallnotificationstatus","off"]);
        return false;
    }
}

function readAllMessages()
{
    location.reload();
}

